
#ifndef PLS_THREAD_STATE_H
#define PLS_THREAD_STATE_H

#include <random>

#include "pls/internal/data_structures/aligned_stack.h"
#include "abstract_task.h"

namespace pls {
    namespace internal {
        namespace scheduling {
            // forward declaration
            class scheduler;

            struct thread_state {
                scheduler* scheduler_;
                abstract_task* root_task_;
                abstract_task* current_task_;
                data_structures::aligned_stack* task_stack_;
                size_t id_;
                base::spin_lock lock_;
                std::minstd_rand random_;

                thread_state():
                    scheduler_{nullptr},
                    root_task_{nullptr},
                    current_task_{nullptr},
                    task_stack_{nullptr},
                    id_{0},
                    random_{id_} {};

                thread_state(scheduler* scheduler, data_structures::aligned_stack* task_stack, unsigned int id):
                    scheduler_{scheduler},
                    root_task_{nullptr},
                    current_task_{nullptr},
                    task_stack_{task_stack},
                    id_{id},
                    random_{id_} {}
            };
        }
    }
}

#endif //PLS_THREAD_STATE_H
